routes/web.php
<?php

use App\Http\Controllers\Web\CustomersController;
use App\Http\Controllers\Web\DashboardController;
use App\Http\Controllers\Web\UploadsController;
use Illuminate\Support\Facades\Route;


Route::get('/', [DashboardController::class, 'index'])->name('home');

Route::resource('uploads', UploadsController::class, ['only' => ['create', 'store']]);

Route::get('customers', [CustomersController::class, 'index'])->name('customers');

app/Models/Customer.php
<?php

namespace App\Models;

use App\Models\Traits\DataValidator;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Arr;
use Illuminate\Support\Str;

class Customer extends Model
{
    use DataValidator;

    protected $fillable = [
        'first_name',
        'last_name',
        'email',
        'email_validated',
        'gender',
        'ip_address',
        'company',
        'city',
        'title',
        'website',
    ];

    const GENDERS = [
        'female' => 'Feminino',
        'male'   => 'Masculino',
    ];

    /**
     * @return string|void
     */
    public function getGenderShowAttribute()
    {
        if ($this->gender) {
            return Arr::get(self::GENDERS, $this->gender);
        }
    }

    /**
     * @param string|null $value
     * @return void
     */
    public function setLastNameAttribute(string $value = null)
    {
        if ($value) {
            $this->attributes['last_name'] = $value;
        }
    }

    /**
     * @param string|null $value
     * @return void
     */
    public function setGenderAttribute(string $value = null)
    {
        $gender = Str::lower($value);

        if (Arr::exists(self::GENDERS, $gender)) {
            $this->attributes['gender'] = $gender;
        }
    }

    /**
     * @param string|null $email
     * @return void
     */
    public function setEmailAttribute(string $email = null)
    {
        $this->attributes['email'] = $email;
        $this->attributes['email_validated'] = $this->isValid($email, 'required|email');
    }
}

app/Models/Traits/DataValidator.php
<?php

namespace App\Models\Traits;

use Illuminate\Support\Facades\Validator;

trait DataValidator
{
    /**
     * @param mixed $value
     * @param string $rules
     * @return bool
     */
    public function isValid($value, string $rules)
    {
        $validator = Validator::make(compact('value'), ['value' => $rules]);

        return !$validator->fails();
    }
}

app/Models/Upload.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Upload extends Model
{
    protected $table = 'uploads';

    protected $fillable = [
        'filename',
        'filename_original',
        'processed',
    ];

    const PATH = 'app/';

    public function getFilePathAttribute()
    {
        return storage_path(self::PATH . $this->filename);
    }

    /**
     * @return void
     */
    public function setProcessed()
    {
        $this->update(['processed' => true]);
    }
}

app/Http/Controllers/Api/CustomersController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Http\Resources\CustomerResource;
use App\Http\Resources\CustomersStatisticsResource;
use App\Repositories\CustomerRepository;

class CustomersController extends Controller
{
    /**
     * @var CustomerRepository
     */
    private $customerRepo;

    /**
     * CustomersController constructor.
     */
    public function __construct()
    {
        $this->customerRepo = new CustomerRepository;
    }

    /**
     * @return \Illuminate\Http\Resources\Json\AnonymousResourceCollection
     */
    public function index()
    {
        return CustomerResource::collection(
            $this->customerRepo->paginate(20, 'first_name')
        );
    }

    /**
     * @return CustomersStatisticsResource
     */
    public function statistics()
    {
        return new CustomersStatisticsResource(
            $this->customerRepo->getStatistics()
        );
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/Web/CustomersController.php
<?php

namespace App\Http\Controllers\Web;

use App\Http\Controllers\Controller;

class CustomersController extends Controller
{
    /**
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        return view('customers.index');
    }
}

app/Http/Controllers/Web/DashboardController.php
<?php

namespace App\Http\Controllers\Web;

use App\Http\Controllers\Controller;

class DashboardController extends Controller
{
    /**
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        return view('dashboard');
    }
}

app/Http/Controllers/Web/UploadsController.php
<?php

namespace App\Http\Controllers\Web;

use App\Http\Controllers\Controller;
use App\Http\Requests\Web\Uploads\StoreRequest;
use App\Jobs\Upload\Store;

class UploadsController extends Controller
{
    /**
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {
        return view('uploads.create');
    }

    /**
     * @param StoreRequest $request
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store(StoreRequest $request)
    {
        try {
            Store::dispatchNow($request->file('file'));
        } catch (\Exception $exception) {
            return back()->with('error', $exception->getMessage());
        }

        return redirect()
            ->route('web.customers')
            ->with('success', 'Clientes importados para a base de dados com sucesso!');
    }
}

resources/views/_layouts/alerts.blade.php
@if($success = session()->get('success'))
    <flash-alert text="{{ $success }}"></flash-alert>
@endif

@if($error = session()->get('error'))
    <flash-alert text="{{ $error }}" theme="error"></flash-alert>
@endif

resources/views/_layouts/form-error.blade.php
@error($field)
<span class="block w-full mt-2 text-sm text-red-700">{{ $message }}</span>
@enderror

resources/views/_layouts/master.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>@yield('title') | Giver</title>

    <link href="{{ asset('static/css/app.css') }}" rel="stylesheet"/>
</head>

<body class="bg-gray-100">

<div id="app">
    @include('_layouts.navbar')

    <div class="container mx-auto py-10" v-cloak>
        <div class="w-full lg:w-2/3 mx-auto">
            @include('_layouts.alerts')
        </div>

        @yield('content')
    </div>
</div>

<script src="{{ asset('static/js/app.js') }}"></script>

</body>
</html>

resources/views/_layouts/navbar.blade.php
<navbar inline-template>
    <header class="bg-gray-800 shadow-lg">
        <nav class="container flex items-center justify-between flex-wrap bg-gray-800 p-6 mx-auto">
            <div class="flex items-center flex-shrink-0 text-white mr-6">
                <a href="{{ route('web.home') }}" class="font-semibold text-xl tracking-tight">
                    Giver
                </a>
            </div>
            <div class="block lg:hidden">
                <button class="flex items-center px-3 py-2 border rounded text-gray-400 border-gray-400 hover:text-white hover:border-white"
                        @click="mobileToggle">
                    <svg class="fill-current h-3 w-3" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg">
                        <title>Menu</title>
                        <path d="M0 3h20v2H0V3zm0 6h20v2H0V9zm0 6h20v2H0v-2z"/>
                    </svg>
                </button>
            </div>
            <div class="w-full flex-grow lg:flex lg:items-center lg:w-auto" :class="optionsClass">
                <div class="text-sm lg:flex-grow">
                    <a class="block mt-4 lg:inline-block lg:mt-0 text-gray-200 hover:text-white mr-4"
                       href="{{ route('web.uploads.create') }}">
                        Importar Arquivo
                    </a>
                    <a class="block mt-4 lg:inline-block lg:mt-0 text-gray-200 hover:text-white mr-4"
                       href="{{ route('web.customers') }}">
                        Clientes
                    </a>
                </div>
            </div>
        </nav>
    </header>
</navbar>

resources/views/customers/index.blade.php
@extends('_layouts.master')

@section('title', 'Clientes')

@section('content')
    <customers-index inline-template>
        <div class="w-full rounded overflow-hidden bg-white shadow-md mx-auto">
            <div class="px-6 py-4">
                <div class="font-bold text-xl mb-2 text-gray-800">Clientes</div>
                <hr>
            </div>

            <div class="px-6 py-4">
                <table class="table-auto border-collapse w-full">
                    <thead>
                    <tr class="rounded-lg font-medium text-gray-700 text-left">
                        <th class="px-4 py-2 bg-gray-200">Nome</th>
                        <th class="px-4 py-2 bg-gray-200">Sobrenome</th>
                        <th class="px-4 py-2 bg-gray-200">E-mail</th>
                        <th class="px-4 py-2 bg-gray-200">Gênero</th>
                        <th class="px-4 py-2 bg-gray-200">Empresa</th>
                        <th class="px-4 py-2 bg-gray-200">Profissão</th>
                        <th class="px-4 py-2 bg-gray-200">Cidade</th>
                        <th class="px-4 py-2 bg-gray-200">Site</th>
                    </tr>
                    </thead>
                    <tbody class="text-sm font-normal text-gray-700">
                    <tr v-for="customer in customers" class="hover:bg-gray-100 border-b border-gray-200 py-10">
                        <td class="px-4 py-4">@{{ customer.first_name }}</td>
                        <td class="px-4 py-4">@{{ customer.last_name }}</td>
                        <td class="px-4 py-4">@{{ customer.email }}</td>
                        <td class="px-4 py-4">@{{ customer.gender_show }}</td>
                        <td class="px-4 py-4">@{{ customer.company }}</td>
                        <td class="px-4 py-4">@{{ customer.title }}</td>
                        <td class="px-4 py-4">@{{ customer.city }}</td>
                        <td class="px-4 py-4">
                            <a v-if="customer.website" :href="customer.website" target="_blank" class="hover:underline">
                                Link
                            </a>
                        </td>
                    </tr>
                    <tr v-if="customers && customers.length === 0">
                        <td colspan="9" class="py-6 text-center">
                            Nenhum cliente cadastrado.
                        </td>
                    </tr>
                    </tbody>
                </table>

                <paginate v-if="lastPage > 1" :page-count="lastPage" :click-handler="loadCustomers" :prev-text="'<'"
                          :next-text="'>'" :container-class="'pagination my-4'">
                </paginate>
            </div>
        </div>
    </customers-index>
@endsection

resources/views/dashboard.blade.php
@extends('_layouts.master')

@section('title', 'Clientes')

@section('content')
    <dashboard inline-template>
        <div class="w-full rounded overflow-hidden bg-white shadow-md mx-auto">
            <div class="px-6 py-4">
                <div class="font-bold text-xl mb-2 text-gray-800">Estatísticas dos clientes</div>
                <hr>
            </div>

            <div v-if="statistics.total === 0" class="block text-center py-8 text-gray-800">
                Ainda não há dados para serem processados.
            </div>

            <div class="px-6 py-4 md:flex items-center" v-else>
                <div class="w-full block md:w-1/4 md:inline-block mx-auto py-4">
                    <doughnut-chart :data="[statistics.total_with_last_name, statistics.total_without_last_name]"
                                    :labels="['Com gênero', 'Sem gênero']" :colors="['#805AD5', '#D53F8C']">
                    </doughnut-chart>
                </div>
                <div class="w-full block md:w-1/4 md:inline-block mx-auto py-4">
                    <doughnut-chart :labels="['E-mails válidos', 'E-mails inválidos']" :colors="['#3182CE', '#E53E3E']"
                                    :data="[statistics.total_with_email_validated, statistics.total_without_email_validated]">
                    </doughnut-chart>
                </div>
                <div class="w-full block md:w-1/4 md:inline-block mx-auto py-4">
                    <doughnut-chart :data="[statistics.total_with_gender, statistics.total_without_gender]"
                                    :labels="['Com gênero', 'Sem gênero']" :colors="['#38A169', '#D69E2E']">
                    </doughnut-chart>
                </div>
            </div>
        </div>
    </dashboard>
@endsection

resources/views/uploads/create.blade.php
@extends('_layouts.master')

@section('title', 'Importar arquivo')

@section('content')

    <div class="w-full sm:w-1/2 rounded overflow-hidden bg-white shadow-md mx-auto">
        <div class="px-6 py-4">
            <div class="font-bold text-xl mb-2 text-gray-800">Importar arquivo</div>
            <hr>
        </div>

        <div class="px-6 py-4">
            <form action="{{ route('web.uploads.store') }}" method="post" enctype="multipart/form-data">
                @csrf

                <div class="mb-4">
                    <label class="default" for="file">
                        Arquivo:
                    </label>

                    <input type="file" name="file" id="file">

                    @include('_layouts.form-error', ['field' => 'file'])
                </div>

                <div class="flex pt-4 items-center justify-between">
                    <button class="default-submit" type="submit">Salvar</button>
                </div>
            </form>
        </div>
    </div>

@endsection